Create Service Plan
This endpoint creates a new service plan with a custom definition. The service offering
must support the plan_definitions feature via OSMAPI. The plan is created by sending
the definition to the service broker, which then triggers a catalog sync to register
the plan in Cloud Foundry. This endpoint requires admin or service_admin role privileges.
The name and description fields must match between the top-level and the definition object.
Request body for creating a service plan
Show optional properties
{
"name": "string",
"description": "string",
"relationships": {
"service_offering": {
"data": {
"guid": "string"
}
}
},
"definition": {
"name": "string",
"description": "string"
}
}
{
"name": "my-custom-plan",
"description": "A custom service plan with specific configuration",
"relationships": {
"service_offering": {
"data": {
"guid": "1234abcd-5678-9abc-def0-123456789abc"
}
}
},
"definition": {
"plan_id": "custom-plan-id-123",
"name": "my-custom-plan",
"description": "A custom service plan with specific configuration",
"properties": {
"cpu": "4",
"memory": "8GB",
"storage": "100GB"
},
"metadata": {
"display_name": "Custom Plan",
"tier": "premium"
}
},
"metadata": {
"labels": {
"environment": "production"
},
"annotations": {
"note": "Custom plan for high-performance workloads"
}
}
}
Created
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"service_offering_guid": "string",
"service_offering_name": "string",
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"service_offering": {
"href": "string",
"method": "string"
},
"visibility": {
"href": "string",
"method": "string"
}
},
"included": {
"spaces": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"name": "string",
"relationships": {
"organization": {
"data": {
"guid": "string"
}
},
"quota": {
"data": {
"guid": "string"
}
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"organization": {
"href": "string",
"method": "string"
},
"features": {
"href": "string",
"method": "string"
},
"apply_manifest": {
"href": "string",
"method": "string"
}
},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"included": "IncludedResources Object"
}
],
"organizations": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"name": "string",
"suspended": false,
"relationships": {
"quota": {
"data": {
"guid": "string"
}
}
},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"domains": {
"href": "string",
"method": "string"
},
"quota": {
"href": "string",
"method": "string"
},
"default_domain": {
"href": "string",
"method": "string"
}
}
}
],
"domains": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"name": "string",
"internal": false,
"router_group": {
"guid": "string"
},
"supported_protocols": [
"string"
],
"relationships": {},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"organization": {
"href": "string",
"method": "string"
},
"route_reservations": {
"href": "string",
"method": "string"
},
"shared_organizations": {
"href": "string",
"method": "string"
},
"router_group": {
"href": "string",
"method": "string"
}
}
}
],
"service_offerings": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"name": "string",
"description": "string",
"available": false,
"tags": [
"string"
],
"requires": [
"string"
],
"shareable": false,
"documentation_url": "string",
"broker_catalog": {
"id": "string",
"metadata": {
"displayName": "string",
"documentationUrl": "string",
"imageUrl": "string",
"longDescription": "string",
"providerDisplayName": "string",
"supportUrl": "string"
},
"features": {
"plan_updateable": false,
"bindable": false,
"instances_retrievable": false,
"bindings_retrievable": false,
"allow_context_updates": false
}
},
"relationships": {
"service_broker": {
"data": {
"guid": "string"
}
}
},
"service_broker_guid": "string",
"service_broker_name": "string",
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"service_plans": {
"href": "string",
"method": "string"
},
"service_broker": {
"href": "string",
"method": "string"
}
}
}
],
"service_instances": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"type": "string",
"name": "string",
"tags": [
"string"
],
"syslog_drain_url": "string",
"route_service_url": "string",
"dashboard_url": "string",
"maintenance_info": {
"version": "string",
"description": "string"
},
"upgrade_available": false,
"last_operation": {
"type": "string",
"state": "string",
"description": "string",
"created_at": "string",
"updated_at": "string"
},
"relationships": {
"space": {
"data": {
"guid": "string"
}
},
"service_plan": {
"data": {
"guid": "string"
}
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"space": {
"href": "string",
"method": "string"
},
"service_plan": {
"href": "string",
"method": "string"
},
"parameters": {
"href": "string",
"method": "string"
},
"service_credential_bindings": {
"href": "string",
"method": "string"
},
"service_route_bindings": {
"href": "string",
"method": "string"
},
"shared_spaces": {
"href": "string",
"method": "string"
}
},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
}
}
],
"apps": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"name": "string",
"state": "string",
"lifecycle": {
"type": "string",
"data": {
"buildpacks": [
"string"
],
"stack": "string",
"credentials": {
"credentials": {
"username": "string",
"password": "string",
"token": "string"
}
}
}
},
"relationships": {},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"space": {
"href": "string",
"method": "string"
},
"processes": {
"href": "string",
"method": "string"
},
"packages": {
"href": "string",
"method": "string"
},
"environment_variables": {
"href": "string",
"method": "string"
},
"current_droplet": {
"href": "string",
"method": "string"
},
"droplets": {
"href": "string",
"method": "string"
}
},
"included": "IncludedResources Object"
}
],
"routes": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"protocol": "string",
"host": "string",
"path": "string",
"port": 0,
"url": "string",
"relationships": {},
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
},
"space": {
"href": "string",
"method": "string"
},
"domain": {
"href": "string",
"method": "string"
},
"destinations": {
"href": "string",
"method": "string"
}
},
"included": "IncludedResources Object"
}
],
"users": [
{
"guid": "string",
"created_at": "string",
"updated_at": "string",
"username": "string",
"presentation_name": "string",
"origin": "string",
"metadata": {
"labels": {
"labels": "string"
},
"annotations": {
"annotations": "string"
}
},
"links": {
"self": {
"href": "string",
"method": "string"
}
}
}
]
}
}
Bad Request
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Unauthorized
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Forbidden
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Not Found
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Conflict
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Unprocessable Entity
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
Internal Server Error
{
"errors": [
{
"code": 0,
"detail": "string",
"title": "string"
}
]
}
errors
curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{"name":"string","description":"string","relationships":"object","definition":"object"}' https://{api_host}/v3/service_plans